<?

function &bdecode( $bEncString )
{
	$data = &bdecode_int( $bEncString , 0 );
	return $data[ 1 ];
}

function &bdecode_int( $bEncString , $c )
{
	if( strlen( substr( $bEncString , $c ) ) )
	{
		switch( $bEncString[ $c ] )
		{
			case 'd':
			case 'D':
				$c++;
				$dict = array();
				while( $bEncString[ $c ] != "e" )
				{
					$data = &bdecode_int( $bEncString , $c );
					$key_name = $data[ 1 ];
					$data = &bdecode_int( $bEncString , $data[ 0 ] );
					$dict[ "$key_name" ] = $data[ 1 ];
					$c = $data[ 0 ];
				}
				$data = array( $c + 1 , $dict );
				break;
			case 'l':
			case 'L':
				$c++;
				$list = array();
				while( $bEncString[ $c ] != "e" )
				{
					$data = &bdecode_int( $bEncString , $c );
					$list[] = $data[ 1 ];
					$c = $data[ 0 ];
				}
				$data = array( $c + 1 , $list );
				break;
			case 'i':
			case 'I':
				$c++;
				$number = "";
				while( $bEncString[ $c ] != "e" )
					$number .= $bEncString[ $c++ ];
				$data = array( $c + 1 , round( (float) $number ) );
				break;
			default:
				$length = "";
				while( $bEncString[ $c ] != ":" )
					$length .= $bEncString[ $c++ ];
				$c++;
				for( $x = $c + intval( $length ) , $value = "" ; $c < $x ; $c++ )
					$value .= $bEncString[ $c ];
				$data = array( $c , $value );
				break;
		}
	}
	else
		$data = array( 0 , NULL );

	return $data;
}

function bencode( &$data )
{
	if( is_array( $data ) )
	{
		$array_keys = array_keys( $data );
		$array_values = array_values( $data );

		for( $x = count( $array_keys ) - 1 ; ( ( $x >= 0 ) && ( is_integer( $array_keys[ $x ] ) ) && ( $array_keys[ $x ] == $x ) ) ; $x-- );

		if( $x >= 0 )
		{
			$bEncString = "d";

			ksort( $data , SORT_STRING );

			for( $y = count( $data ) , $x = 0 ; $x < $y ; $x++ )
				$bEncString .= bencode( $array_keys[ $x ] ) . bencode( $array_values[ $x ] );

			$bEncString .= "e";
		}
		else
		{
			$bEncString = "l";

			foreach( $data as $element )
				$bEncString .= bencode( $element );

			$bEncString .= "e";
		}
	}
	else
	{
		if( is_integer( $data ) || is_float( $data ) )
			$bEncString = "i" . $data . "e";
		else
		{
			$data = strval( $data );
			$bEncString = strlen( $data ) . ":" . $data;
		}
	}

	return $bEncString;
}

function &read_file( $filename )
{
	if( $dfp = fopen( $filename , "rb" ) )
	{
		while( !flock( $dfp , LOCK_SH ) );

		$dinfo = "";
		while( !feof( $dfp ) )
			$dinfo .= fread( $dfp , 4096 );

		$data = bdecode( $dinfo );

		flock( $dfp , LOCK_UN );
		fclose( $dfp );
	}
	else
		$data = NULL;

	return $data;
}

function write_file( &$data , $filename )
{
	$bEncString = bencode( $data );

	if( ( $dfp = fopen( $filename , "wb" ) ) && strlen( $bEncString ) )
	{
		while( !flock( $dfp , LOCK_EX ) );

		$result = fwrite( $dfp , $bEncString );

		flock( $dfp , LOCK_UN );
		fclose( $dfp );
	}
	else
		$result = NULL;

	return $result;
}

function compress_hash( $hash )
{
	if( strlen( $hash ) == 40 )
	{
		for( $hash_binary = "" , $hash_compressed = "" , $x = 0 ; $x < 40 ; $x++ )
		{
			$hash_binary .= sprintf( "%04d" , base_convert( $hash[ $x ] , 16 , 2 ) );
			if( $x % 2 )
			{
				$hash_compressed .= chr( bindec( $hash_binary ) );
				$hash_binary = "";
			}
		}
		return $hash_compressed;
	}
}

function url_compress_hash( $hash )
{

	if( strlen( $hash ) == 40 )
	{
		$hash_url_compressed = "";

		for( $x = 0 ; $x < 40 ; $x += 2 )
			$hash_url_compressed .= "%" . strtoupper( $hash[ $x ] . $hash[ $x + 1 ] );
	}

	return $hash_url_compressed;
}

function urlexpand( $varname )
{
	$url = "http://" . $_SERVER[ "HTTP_HOST" ] . $_SERVER[ "REQUEST_URI" ];
	$url_array = parse_url( $url );
	$url_query = $url_array[ "query" ];
	$queries = explode( "&" , $url_query );

	for( $z = strlen( $varname ) , $y = count( $queries ) , $x = 0 ; $x < $y ; $x++ )
	{
		if( !strcasecmp( substr( $queries[ $x ] , 0 , $z ) , $varname ) )
		{
			$hashURL = substr( $queries[ $x ] , $z + 1 ) ;
			$x = $y;
		}
	}

	for( $expanded = "" , $x = 0 , $y = 0 ; $x < 20 ; $x++ )
	{
		if( $hashURL[ $y ] == "%" )
		{
			$expanded .= strtolower( $hashURL[ $y + 1 ] . $hashURL[ $y + 2 ] );
			$y += 3;
		}
		else
		{
			$binary = sprintf( "%08b" , ord( $hashURL[ $y ] ) );
			$newbinary = "0000" . substr( $binary , 0 , 4 );
			$expanded .= base_convert( $newbinary , 2 , 16 );
			$newbinary = "0000" . substr( $binary , 4 , 4 );
			$expanded .= base_convert( $newbinary , 2 , 16 );
			$y++;
		}
	}

	return $expanded;
}

function count_completes( &$my_peer_array )
{
	$to_return = 0;

	if( $y = count( $my_peer_array ) )
	{
		$peer_ids = array_keys( $my_peer_array );

		for( $x = 0 ; $x < $y ; $x++ )
		{
			if( !$my_peer_array[ $peer_ids[ $x ] ][ "left" ] )
				$to_return++;
		}
	}

	return $to_return;
}

function count_incompletes( &$my_peer_array )
{
	$to_return = 0;

	if( $y = count( $my_peer_array ) )
	{
		$peer_ids = array_keys( $my_peer_array );

		for( $x = 0 ; $x < $y ; $x++ )
		{
			if( $my_peer_array[ $peer_ids[ $x ] ][ "left" ] )
				$to_return++;
		}
	}

	return $to_return;
}

function find_peer_id( $my_peer_id , &$my_peers )
{
	$to_return = FALSE;

	if( $y = count( $my_peers ) )
	{
		$info_hashes = array_keys( $my_peers );

		for( $x = 0 ; ( $x < $y ) && ( $to_return === FALSE ) ; $x++ )
		{
			if( array_key_exists( $my_peer_id , $my_peers[ $info_hashes[ $x ] ] ) )
				$to_return = $hashes[ $x ];
		}
	}

	return $to_return;
}

function &find_ip( $my_ip , &$my_peers )
{
	$to_return = FALSE;

	if( $y = count( $my_peers ) )
	{
		$info_hashes = array_keys( $my_peers );

		for( $x = 0 ; $x < $y ; $x++ )
		{
			if( $peer_id = find_ip_peer_array( $my_ip , $my_peers[ $info_hashes[ $x ] ] ) )
			{
				if( !is_array( $to_return ) )
					$to_return = array();

				$to_return[ $info_hashes[ $x ] ] = $peer_id;
			}
		}
	}

	return $to_return;
}

function find_ip_peer_array( $my_ip , &$my_peer_array )
{
	$to_return = FALSE;

	if( $y = count( $my_peer_array ) )
	{
		$peer_ids = array_keys( $my_peer_array );

		for( $x = 0 ; ( $x < $y ) && ( $to_return === FALSE ) ; $x++ )
		{
			if( !strcmp( $my_peer_array[ $peer_ids[ $x ] ][ "ip" ] , $my_ip ) )
				$to_return = $peer_ids[ $x ];
		}
	}

	return $to_return;
}

?>